using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_Ventas._0_Modelos;
using Exferia_Ventas.General;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Ventas._1_Datos
{
    public class VTA_RemesasCabecera_TipoCapturaDocumento_Datos : ABS_Datos
    {
        #region Listado

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }

        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }

        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }

        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }

        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }

        #endregion

        #region Obtener
        public override dynamic Obtener(long _lng_id)
        {
            return null;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            return null;
        }

        #endregion

        #region MODELOS

        #region Modelo Simple
        private VTA_RemesasCabecera_TipoCapturaDocumento g_mdl_VTA_RemesasCabecera_TipoCapturaDocumento = null;
        public VTA_RemesasCabecera_TipoCapturaDocumento Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                 //WHERE
                                 " WHERE " + nameof(VTA_RemesasCabecera_TipoCapturaDocumento) + "." + nameof(VTA_RemesasCabecera_TipoCapturaDocumento.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);


            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_RemesasCabecera_TipoCapturaDocumento_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_VTA_RemesasCabecera_TipoCapturaDocumento;
        }

        #region Ejecutar Consulta Modelo

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_VTA_RemesasCabecera_TipoCapturaDocumento = obj_Exferia_Entities.Database.SqlQuery<VTA_RemesasCabecera_TipoCapturaDocumento>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_RemesasCabecera_TipoCapturaDocumento_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #endregion

        #region Modelo Listado
        private List<VTA_RemesasCabecera_TipoCapturaDocumento> g_lst_VTA_RemesasCabecera_TipoCapturaDocumento = null;

        public List<VTA_RemesasCabecera_TipoCapturaDocumento> Obtener_ModeloListado_Por_RemesaCabecera(long _lng_idRemesaCabecera)
        {
            try
            {

                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " +
                                        nameof(VTA_RemesasCabecera_TipoCapturaDocumento) + "." + nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaBorrado) + " is null and " +
                                        nameof(VTA_RemesasCabecera_TipoCapturaDocumento) + "." + nameof(VTA_RemesasCabecera_TipoCapturaDocumento.idRemesaCabecera) + "=@idRemesaCabecera";



                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idRemesaCabecera",  _lng_idRemesaCabecera)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_RemesasCabecera_TipoCapturaDocumento_Datos) + "/" + nameof(Obtener_ModeloListado_Por_RemesaCabecera), true);
            }

            return g_lst_VTA_RemesasCabecera_TipoCapturaDocumento;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el modelo
                g_lst_VTA_RemesasCabecera_TipoCapturaDocumento = obj_Exferia_Entities.Database.SqlQuery<VTA_RemesasCabecera_TipoCapturaDocumento>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_RemesasCabecera_TipoCapturaDocumento_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento) + "." + nameof(VTA_RemesasCabecera_TipoCapturaDocumento.id) + " , " +
                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento) + "." + nameof(VTA_RemesasCabecera_TipoCapturaDocumento.idRemesaCabecera) + " , " +
                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento) + "." + nameof(VTA_RemesasCabecera_TipoCapturaDocumento.idDelegacion) + " , " +
                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento) + "." + nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaInicio) + " , " +
                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento) + "." + nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaFinal) + " , " +
                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento) + "." + nameof(VTA_RemesasCabecera_TipoCapturaDocumento.documentoInicio) + " , " +
                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento) + "." + nameof(VTA_RemesasCabecera_TipoCapturaDocumento.documentoFinal) + " , " +
                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento) + "." + nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaBorrado) +
               " FROM " + nameof(VTA_RemesasCabecera_TipoCapturaDocumento);
        }
        #endregion


        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                VTA_RemesasCabecera_TipoCapturaDocumento mdl_VTA_RemesasCabecera_TipoCapturaDocumento_AGrabar = (VTA_RemesasCabecera_TipoCapturaDocumento)_mdl_obj;
                VTA_RemesasCabecera_TipoCapturaDocumento mdl_VTA_RemesasCabecera_TipoCapturaDocumento_DatosViejos = new VTA_RemesasCabecera_TipoCapturaDocumento();

                // Ver si existe ######################################################################
                VTA_RemesasCabecera_TipoCapturaDocumento mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final = Obtener_Modelo_Por_Id(mdl_VTA_RemesasCabecera_TipoCapturaDocumento_AGrabar.id);
                //###################################################################################### 

                if (mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final, mdl_VTA_RemesasCabecera_TipoCapturaDocumento_DatosViejos, false, false);

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_VTA_RemesasCabecera_TipoCapturaDocumento_AGrabar, mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(VTA_RemesasCabecera_TipoCapturaDocumento) +
                                            " SET " +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.idRemesaCabecera) + "=@idRemesaCabecera," +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.idDelegacion) + "=@idDelegacion," +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaInicio) + "=@fechaInicio," +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaFinal) + "=@fechaFinal," +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.documentoInicio) + "=@documentoInicio," +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.documentoFinal) + "=@documentoFinal," +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idRemesaCabecera",  mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.idRemesaCabecera),
                        new SqlParameter("@idDelegacion",  mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.idDelegacion),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaInicio!=null
                            ?   new SqlParameter("@fechaInicio", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaInicio.Value)
                            :   new SqlParameter("@fechaInicio",  DBNull.Value),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaFinal!=null
                            ?   new SqlParameter("@fechaFinal", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaFinal.Value)
                            :   new SqlParameter("@fechaFinal",  DBNull.Value),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.documentoInicio!=null
                            ?   new SqlParameter("@documentoInicio", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.documentoInicio)
                            :   new SqlParameter("@documentoInicio",  DBNull.Value),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.documentoFinal!=null
                            ?   new SqlParameter("@documentoFinal", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.documentoFinal)
                            :   new SqlParameter("@documentoFinal",  DBNull.Value),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.id;
                }
                else
                {
                    mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final = new VTA_RemesasCabecera_TipoCapturaDocumento();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_VTA_RemesasCabecera_TipoCapturaDocumento_AGrabar, mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(VTA_RemesasCabecera_TipoCapturaDocumento) +
                                            " (" +
                                                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento.idRemesaCabecera) + "," +
                                                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento.idDelegacion) + "," +
                                                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaInicio) + "," +
                                                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaFinal) + "," +
                                                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento.documentoInicio) + "," +
                                                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento.documentoFinal) + "," +
                                                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaBorrado) +
                                            " ) " +
                                            " OUTPUT INSERTED." + nameof(VTA_RemesasCabecera_TipoCapturaDocumento.id) +
                                            " VALUES " +
                                            " ( " +
                                                "@idRemesaCabecera," +
                                                "@idDelegacion," +
                                                "@fechaInicio," +
                                                "@fechaFinal," +
                                                "@documentoInicio," +
                                                "@documentoFinal," +
                                                "@fechaBorrado" +
                                            " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idRemesaCabecera",  mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.idRemesaCabecera),
                        new SqlParameter("@idDelegacion",  mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.idDelegacion),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaInicio!=null
                            ?   new SqlParameter("@fechaInicio", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaInicio.Value)
                            :   new SqlParameter("@fechaInicio",  DBNull.Value),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaFinal!=null
                            ?   new SqlParameter("@fechaFinal", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaFinal.Value)
                            :   new SqlParameter("@fechaFinal",  DBNull.Value),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.documentoInicio!=null
                            ?   new SqlParameter("@documentoInicio", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.documentoInicio)
                            :   new SqlParameter("@documentoInicio",  DBNull.Value),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.documentoFinal!=null
                            ?   new SqlParameter("@documentoFinal", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.documentoFinal)
                            :   new SqlParameter("@documentoFinal",  DBNull.Value),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(VTA_RemesasCabecera_TipoCapturaDocumento), mdl_VTA_RemesasCabecera_TipoCapturaDocumento_DatosViejos, mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_RemesasCabecera_TipoCapturaDocumento_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public INTERNO_ValorDevuelto_Modelo Insertar(VTA_RemesasCabecera_TipoCapturaDocumento _mdl_VTA_RemesasCabecera_TipoCapturaDocumento_AGrabar)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                VTA_RemesasCabecera_TipoCapturaDocumento mdl_VTA_RemesasCabecera_TipoCapturaDocumento_DatosViejos = new VTA_RemesasCabecera_TipoCapturaDocumento();
                VTA_RemesasCabecera_TipoCapturaDocumento mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final = new VTA_RemesasCabecera_TipoCapturaDocumento();

                //Tipo de Accion que se va a realizar
                mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                //Cargar los Datos del Modelo
                Funciones.CopiarPropiedadesObjetos(_mdl_VTA_RemesasCabecera_TipoCapturaDocumento_AGrabar, mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final, false, false);

                #region INSERT
                string str_SQL_Insert = " INSERT INTO " + nameof(VTA_RemesasCabecera_TipoCapturaDocumento) +
                                        " (" +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.idRemesaCabecera) + "," +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.idDelegacion) + "," +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaInicio) + "," +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaFinal) + "," +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.documentoInicio) + "," +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.documentoFinal) + "," +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaBorrado) +
                                        " ) " +
                                        " OUTPUT INSERTED." + nameof(VTA_RemesasCabecera_TipoCapturaDocumento.id) +
                                        " VALUES " +
                                        " ( " +
                                            "@idRemesaCabecera," +
                                            "@idDelegacion," +
                                            "@fechaInicio," +
                                            "@fechaFinal," +
                                            "@documentoInicio," +
                                            "@documentoFinal," +
                                            "@fechaBorrado" +
                                        " ) ";
                //Parametros
                object[] arr_Parametros_Insert = new object[]
                {
                        new SqlParameter("@idRemesaCabecera",  mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.idRemesaCabecera),
                        new SqlParameter("@idDelegacion",  mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.idDelegacion),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaInicio!=null
                            ?   new SqlParameter("@fechaInicio", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaInicio.Value)
                            :   new SqlParameter("@fechaInicio",  DBNull.Value),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaFinal!=null
                            ?   new SqlParameter("@fechaFinal", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaFinal.Value)
                            :   new SqlParameter("@fechaFinal",  DBNull.Value),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.documentoInicio!=null
                            ?   new SqlParameter("@documentoInicio", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.documentoInicio)
                            :   new SqlParameter("@documentoInicio",  DBNull.Value),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.documentoFinal!=null
                            ?   new SqlParameter("@documentoFinal", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.documentoFinal)
                            :   new SqlParameter("@documentoFinal",  DBNull.Value),
                        mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                };
                #endregion

                //Id de la tabla
                mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_RemesasCabecera_TipoCapturaDocumento_Datos) + "/" + nameof(Insertar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            bool bol_ActualizarFechaBorrado = false;//Este campo se utiliza por si no se puede borrar, que actualice la fecha de borrado

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                VTA_RemesasCabecera_TipoCapturaDocumento mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final != null)
                {
                    //Se intenta borrar, si diera un error porque esta relacaionado se graba la fecha de baja
                    try
                    {

                        #region Delete
                        string str_SQL_Delete = " DELETE FROM  " + nameof(VTA_RemesasCabecera_TipoCapturaDocumento) +
                                                " WHERE " +
                                                    nameof(VTA_RemesasCabecera_TipoCapturaDocumento.id) + "=@id";
                        //Parametros
                        object[] arr_Parametros_Delete = new object[]
                        {
                            new SqlParameter("@id", _lng_id)
                        };
                        #endregion

                        //Delete
                        obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                        // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                        Datos_Generales.USR_Trazabilidad_Grabar(typeof(VTA_RemesasCabecera_TipoCapturaDocumento), null, mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                    }
                    catch (Exception ex)
                    {
                        var sqlException = ex.GetBaseException() as SqlException;
                        if (sqlException != null)
                        {
                            if (sqlException.Errors.Count > 0)
                            {
                                switch (sqlException.Errors[0].Number)
                                {
                                    case Control_Errores.G_INT_ERRORCONTROLADO_BORRAR_CONFLICTO_CLAVEFORANEA: // Foreign Key violation
                                        bol_ActualizarFechaBorrado = true;
                                        break;
                                    default:
                                        throw;
                                }
                            }
                        }
                        else
                        {
                            throw;
                        }
                    }
                }

                // Actualizar la fecha de baja , al no poder borrarlo por tener relaciones
                if (bol_ActualizarFechaBorrado)
                {
                    // Se graba la fecha de baja
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(VTA_RemesasCabecera_TipoCapturaDocumento) +
                                                " SET " +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(VTA_RemesasCabecera_TipoCapturaDocumento.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(VTA_RemesasCabecera_TipoCapturaDocumento), null, mdl_VTA_RemesasCabecera_TipoCapturaDocumento_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                // Devolver también el Objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_RemesasCabecera_TipoCapturaDocumento_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }


            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}